<template>
  <form @submit.prevent="tryRegister()" novalidate>
    <heading-een :heading="'Registreren'" class="h1-center"></heading-een>
    <FormField id="name"
               v-model="name"
               type="text"
               :required="true"
               label="Naam"
               :error="nameError"></FormField>
    <FormField id="lastname"
               v-model="lastname"
               type="text"
               :required="true"
               label="Achternaam"
               :error="lastnameError"></FormField>
    <FormField id="email"
               v-model="email"
               type="email"
               :required="true"
               label="E-mail"
               :error="emailError"></FormField>
    <FormField id="password"
               v-model="password"
               type="password"
               :required="true"
               label="Wachtwoord"
               :error="passwordError"></FormField>
    <FormField id="passwordAccept"
               v-model="passwordAccept"
               type="password"
               :required="true"
               label="Wachtwoord Bevestigen"
               :error="passwordAcceptError"></FormField>
    <p>
      <router-link :to="{name: 'Login'}">Heeft u al een acount?</router-link>
    </p>
    <div class="btn">
      <button type="submit">Registreren</button>
    </div>
    <Error v-if="error" :value="error"></Error>
    <div class="loading" v-show="loading" role="alert">
      <div class="loading-animate"></div>
    </div>
  </form>
</template>

<script>
import { mapActions } from 'vuex';
import HeadingEen from '../atoms/HeadingEen.vue';
import Error from '../atoms/Error.vue';
import FormField from '../molecules/FormField.vue';

const emailRegex = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;

export default {
  name: 'RegisterForm',
  components: {
    HeadingEen,
    Error,
    FormField,
  },
  data() {
    return {
      name: null,
      lastname: null,
      email: null,
      password: null,
      passwordAccept: null,
      error: null,
      loading: false,
      submitted: false,
    };
  },
  computed: {
    lastnameError() {
      if (!this.submitted) {
        return null;
      }
      if (!this.lastname) {
        return 'Achternaam is een verplicht veld en werd niet ingevuld.';
      }
      return null;
    },
    nameError() {
      if (!this.submitted) {
        return null;
      }
      if (!this.name) {
        return 'Naam is een verplicht veld en werd niet ingevuld.';
      }
      return null;
    },
    emailError() {
      if (!this.submitted) {
        return null;
      }
      if (!this.email) {
        return 'E-mail is een verplicht veld en werd niet ingevuld.';
      }
      if (!emailRegex.test(this.email)) {
        return 'Het opgegeven e-mailadres voldoet niet aan het patroon naam@voorbeeld.be';
      }
      return null;
    },
    passwordError() {
      if (!this.submitted) {
        return null;
      }
      if (!this.password) {
        return 'Wachtwoord is een verplicht veld en werd niet ingevuld.';
      }
      if (this.password.length < 8) {
        return 'Wachtwoord Moet meer dan 8 karakters bevatten';
      }
      return null;
    },
    passwordAcceptError() {
      if (!this.submitted) {
        return null;
      }
      if (!this.passwordAccept) {
        return 'Wachtwoord bevestigen is een verplicht veld en werd niet ingevuld.';
      }
      if (this.passwordAccept !== this.password) {
        return 'Bevestig uw wachtwoord door hetzelfde wachtwoord nog eens te typen';
      }
      return null;
    },
    hasErrors() {
      return this.nameError || this.lastnameError || this.emailError || this.passwordError
        || this.passwordAcceptError;
    },
  },
  methods: {
    ...mapActions('auth', ['register']),
    async tryRegister() {
      this.submitted = true;
      if (this.hasErrors) {
        return;
      }
      this.loading = true;
      try {
        await this.register({
          name: this.name,
          lastname: this.lastname,
          email: this.email,
          password: this.password,
        });
      } catch (e) {
        if (e.response.status === 422) {
          this.error = 'Een of meerdere ingegeven datavelden is niet correct.';
          return;
        }
        this.error = 'Er is een onverwachte fout opgetreden.';
      } finally {
        this.loading = false;
        await this.$router.push({ name: 'Trajectplanner' });
      }
    },
  },
};
</script>

<style scoped lang="scss">
form {
  width: 50%;
  margin: 0 auto;

  .h1-center{
    text-align: center;
    padding-top: 6.5em;
  }

  .btn{
    text-align: center;
    margin: 1em 0;
  }

  button{
    font-family: 'Roboto', sans-serif;
    padding: 15px 0;
    background-color: $my-orange;
    border-radius: 11px;
    border: none;
    width: 170px;
    height: 50px;
    text-align: center;
    color: #f8f8f8;
    font-size: 1.3em;
    /*font-size: 1.8em;*/
  }
  button:hover{
    background-color: $my-yellow;
    transition: .3s;
  }
  a{
    font-size: 1em;
    font-family: 'Roboto', sans-serif;
    color: $my-orange;
  }
  a:hover{
    color: $my-yellow;
    transition: .3s;
  }
}
.loading-animate {
  border: 8px solid #f3f3f3;
  border-radius: 50%;
  border-top: 8px solid $my-blue;
  border-bottom: 8px solid $my-blue;
  width: 60px;
  height: 60px;
  -webkit-animation: spin 2s linear infinite;
  animation: spin 2s linear infinite;
}
.loading {
  display: flex;
  justify-content: center;
  align-items: center;
  position: fixed;
  z-index: 6;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
}

@-webkit-keyframes spin {
  0% { -webkit-transform: rotate(0deg); }
  100% { -webkit-transform: rotate(360deg); }
}

@keyframes spin {
  0% { transform: rotate(0deg); }
  100% { transform: rotate(360deg); }
}
@media (max-width: 952px){
  form {
    width: 90%;
  }
}
</style>
